Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 666)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 667)
@@ -4,5 +4,18 @@
 ! Current revisions:
 ! -----------------
+!
 ! 
+! Exchange of parameters between ocean and atmosphere via PE0
+! Check for illegal combination of ws-scheme and timestep scheme.
+! Check for topography and ws-scheme.
+! Check for not cyclic boundary conditions in combination with ws-scheme and
+! loop_optimization = 'vector'.
+! Check for call_psolver_at_all_substeps and ws-scheme for momentum_advec.
+!
+! Different processor/grid topology in atmosphere and ocean is now allowed!
+!
+! Bugfixes in checking for conserve_volume_flow_mode
+!
+! Adapt error messages.
 !
 ! Former revisions:
@@ -180,5 +193,5 @@
 !
 !-- Check dt_coupling, restart_time, dt_restart, end_time, dx, dy, nx and ny
-    IF ( coupling_mode /= 'uncoupled' )  THEN
+    IF ( coupling_mode /= 'uncoupled')  THEN
 
        IF ( dt_coupling == 9999999.9 )  THEN
@@ -189,8 +202,12 @@
 
 #if defined( __parallel )
-       CALL MPI_SEND( dt_coupling, 1, MPI_REAL, target_id, 11, comm_inter, &
-                      ierr )
-       CALL MPI_RECV( remote, 1, MPI_REAL, target_id, 11, comm_inter, &
-                      status, ierr )
+       IF ( myid == 0 ) THEN
+          CALL MPI_SEND( dt_coupling, 1, MPI_REAL, target_id, 11, comm_inter, &
+                         ierr )
+          CALL MPI_RECV( remote, 1, MPI_REAL, target_id, 11, comm_inter, &
+                         status, ierr )
+       ENDIF
+       CALL MPI_BCAST( remote, 1, MPI_REAL, 0, comm2d, ierr)
+       
        IF ( dt_coupling /= remote )  THEN
           WRITE( message_string, * ) 'coupling mode "', TRIM( coupling_mode ), &
@@ -200,7 +217,11 @@
        ENDIF
        IF ( dt_coupling <= 0.0 )  THEN
-          CALL MPI_SEND( dt_max, 1, MPI_REAL, target_id, 19, comm_inter, ierr )
-          CALL MPI_RECV( remote, 1, MPI_REAL, target_id, 19, comm_inter, &
-                         status, ierr )
+          IF ( myid == 0  ) THEN
+             CALL MPI_SEND( dt_max, 1, MPI_REAL, target_id, 19, comm_inter, ierr )
+             CALL MPI_RECV( remote, 1, MPI_REAL, target_id, 19, comm_inter, &
+                            status, ierr )
+          ENDIF   
+          CALL MPI_BCAST( remote, 1, MPI_REAL, 0, comm2d, ierr)
+          
           dt_coupling = MAX( dt_max, remote )
           WRITE( message_string, * ) 'coupling mode "', TRIM( coupling_mode ), &
@@ -209,9 +230,12 @@
           CALL message( 'check_parameters', 'PA0005', 0, 1, 0, 6, 0 )
        ENDIF
-
-       CALL MPI_SEND( restart_time, 1, MPI_REAL, target_id, 12, comm_inter, &
-                      ierr )
-       CALL MPI_RECV( remote, 1, MPI_REAL, target_id, 12, comm_inter, &
-                      status, ierr )
+       IF ( myid == 0 ) THEN
+          CALL MPI_SEND( restart_time, 1, MPI_REAL, target_id, 12, comm_inter, &
+                         ierr )
+          CALL MPI_RECV( remote, 1, MPI_REAL, target_id, 12, comm_inter, &
+                         status, ierr )
+       ENDIF 
+       CALL MPI_BCAST( remote, 1, MPI_REAL, 0, comm2d, ierr)
+      
        IF ( restart_time /= remote )  THEN
           WRITE( message_string, * ) 'coupling mode "', TRIM( coupling_mode ), &
@@ -220,9 +244,12 @@
           CALL message( 'check_parameters', 'PA0006', 1, 2, 0, 6, 0 )
        ENDIF
-
-       CALL MPI_SEND( dt_restart, 1, MPI_REAL, target_id, 13, comm_inter, &
-                      ierr )
-       CALL MPI_RECV( remote, 1, MPI_REAL, target_id, 13, comm_inter, &
-                      status, ierr )
+       IF ( myid == 0 ) THEN
+          CALL MPI_SEND( dt_restart, 1, MPI_REAL, target_id, 13, comm_inter, &
+                         ierr )
+          CALL MPI_RECV( remote, 1, MPI_REAL, target_id, 13, comm_inter, &
+                         status, ierr )
+       ENDIF   
+       CALL MPI_BCAST( remote, 1, MPI_REAL, 0, comm2d, ierr)
+      
        IF ( dt_restart /= remote )  THEN
           WRITE( message_string, * ) 'coupling mode "', TRIM( coupling_mode ), &
@@ -233,8 +260,12 @@
 
        simulation_time_since_reference = end_time - coupling_start_time
-       CALL MPI_SEND( simulation_time_since_reference, 1, MPI_REAL, target_id, &
-                      14, comm_inter, ierr )
-       CALL MPI_RECV( remote, 1, MPI_REAL, target_id, 14, comm_inter, &
-                      status, ierr )
+       IF  ( myid == 0 ) THEN
+          CALL MPI_SEND( simulation_time_since_reference, 1, MPI_REAL, target_id, &
+                         14, comm_inter, ierr )
+          CALL MPI_RECV( remote, 1, MPI_REAL, target_id, 14, comm_inter, &
+                         status, ierr )    
+       ENDIF 
+       CALL MPI_BCAST( remote, 1, MPI_REAL, 0, comm2d, ierr)
+      
        IF ( simulation_time_since_reference /= remote )  THEN
           WRITE( message_string, * ) 'coupling mode "', TRIM( coupling_mode ), &
@@ -245,38 +276,70 @@
        ENDIF
 
-       CALL MPI_SEND( dx, 1, MPI_REAL, target_id, 15, comm_inter, ierr )
-       CALL MPI_RECV( remote, 1, MPI_REAL, target_id, 15, comm_inter, &
-                      status, ierr )
-       IF ( dx /= remote )  THEN
-          WRITE( message_string, * ) 'coupling mode "', TRIM( coupling_mode ), &
-                 '":  dx = ', dx, '& is not equal to dx_remote = ', remote
-          CALL message( 'check_parameters', 'PA0009', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       CALL MPI_SEND( dy, 1, MPI_REAL, target_id, 16, comm_inter, ierr )
-       CALL MPI_RECV( remote, 1, MPI_REAL, target_id, 16, comm_inter, &
-                      status, ierr )
-       IF ( dy /= remote )  THEN
-          WRITE( message_string, * ) 'coupling mode "', TRIM( coupling_mode ), &
-                 '":  dy = ', dy, '& is not equal to dy_remote = ', remote
-          CALL message( 'check_parameters', 'PA0010', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       CALL MPI_SEND( nx, 1, MPI_INTEGER, target_id, 17, comm_inter, ierr )
-       CALL MPI_RECV( iremote, 1, MPI_INTEGER, target_id, 17, comm_inter, &
-                      status, ierr )
-       IF ( nx /= iremote )  THEN
-          WRITE( message_string, * ) 'coupling mode "', TRIM( coupling_mode ), &
-                 '": nx = ', nx, '& is not equal to nx_remote = ', iremote
-          CALL message( 'check_parameters', 'PA0011', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       CALL MPI_SEND( ny, 1, MPI_INTEGER, target_id, 18, comm_inter, ierr )
-       CALL MPI_RECV( iremote, 1, MPI_INTEGER, target_id, 18, comm_inter, &
-                      status, ierr )
-       IF ( ny /= iremote )  THEN
-          WRITE( message_string, * ) 'coupling mode "', TRIM( coupling_mode ), &
-                 '": ny = ', ny, '& is not equal to ny_remote = ', iremote
-          CALL message( 'check_parameters', 'PA0012', 1, 2, 0, 6, 0 )
+  
+       IF ( myid == 0 ) THEN
+          CALL MPI_SEND( dx, 1, MPI_REAL, target_id, 15, comm_inter, ierr )
+          CALL MPI_RECV( remote, 1, MPI_REAL, target_id, 15, comm_inter, &
+                                                             status, ierr )
+       ENDIF
+       CALL MPI_BCAST( remote, 1, MPI_REAL, 0, comm2d, ierr)
+
+
+       IF ( coupling_mode == 'atmosphere_to_ocean') THEN
+
+          IF ( dx < remote ) THEN
+             WRITE( message_string, * ) 'coupling mode "', &
+                   TRIM( coupling_mode ),                  &
+           '": dx in Atmosphere is not equal to or not larger then dx in ocean'
+             CALL message( 'check_parameters', 'PA0009', 1, 2, 0, 6, 0 )
+          ENDIF
+
+          IF ( (nx_a+1)*dx /= (nx_o+1)*remote )  THEN
+             WRITE( message_string, * ) 'coupling mode "', &
+                    TRIM( coupling_mode ), &
+             '": Domain size in x-direction is not equal in ocean and atmosphere'
+             CALL message( 'check_parameters', 'PA0010', 1, 2, 0, 6, 0 )
+          ENDIF
+
+       ENDIF
+
+       IF ( myid == 0) THEN
+          CALL MPI_SEND( dy, 1, MPI_REAL, target_id, 16, comm_inter, ierr )
+          CALL MPI_RECV( remote, 1, MPI_REAL, target_id, 16, comm_inter, &
+                         status, ierr )
+       ENDIF
+       CALL MPI_BCAST( remote, 1, MPI_REAL, 0, comm2d, ierr)
+
+       IF ( coupling_mode == 'atmosphere_to_ocean') THEN
+
+          IF ( dy < remote )  THEN
+             WRITE( message_string, * ) 'coupling mode "', &
+                    TRIM( coupling_mode ), &
+                 '": dy in Atmosphere is not equal to or not larger then dy in ocean'
+             CALL message( 'check_parameters', 'PA0011', 1, 2, 0, 6, 0 )
+          ENDIF
+
+          IF ( (ny_a+1)*dy /= (ny_o+1)*remote )  THEN
+             WRITE( message_string, * ) 'coupling mode "', &
+                   TRIM( coupling_mode ), &
+             '": Domain size in y-direction is not equal in ocean and atmosphere'
+             CALL message( 'check_parameters', 'PA0012', 1, 2, 0, 6, 0 )
+          ENDIF
+
+          IF ( MOD(nx_o+1,nx_a+1) /= 0 )  THEN
+             WRITE( message_string, * ) 'coupling mode "', &
+                   TRIM( coupling_mode ), &
+             '": nx+1 in ocean is not divisible without remainder with nx+1 in', & 
+             ' atmosphere'
+             CALL message( 'check_parameters', 'PA0339', 1, 2, 0, 6, 0 )
+          ENDIF
+
+          IF ( MOD(ny_o+1,ny_a+1) /= 0 )  THEN
+             WRITE( message_string, * ) 'coupling mode "', &
+                   TRIM( coupling_mode ), &
+             '": ny+1 in ocean is not divisible without remainder with ny+1 in', & 
+             ' atmosphere'
+             CALL message( 'check_parameters', 'PA0340', 1, 2, 0, 6, 0 )
+          ENDIF
+
        ENDIF
 #else
@@ -290,11 +353,13 @@
 !
 !-- Exchange via intercommunicator
-    IF ( coupling_mode == 'atmosphere_to_ocean' )  THEN
+    IF ( coupling_mode == 'atmosphere_to_ocean' .AND. myid == 0 )  THEN
        CALL MPI_SEND( humidity, 1, MPI_LOGICAL, target_id, 19, comm_inter, &
                       ierr )
-    ELSEIF ( coupling_mode == 'ocean_to_atmosphere' )  THEN
+    ELSEIF ( coupling_mode == 'ocean_to_atmosphere' .AND. myid == 0)  THEN
        CALL MPI_RECV( humidity_remote, 1, MPI_LOGICAL, target_id, 19, &
                       comm_inter, status, ierr )
     ENDIF
+    CALL MPI_BCAST( humidity_remote, 1, MPI_LOGICAL, 0, comm2d, ierr)
+    
 #endif
 
@@ -372,4 +437,13 @@
           CALL message( 'check_parameters', 'PA0014', 1, 2, 0, 6, 0 )
        ENDIF
+       IF ( momentum_advec == 'ws-scheme' .OR. scalar_advec == 'ws-scheme' ) &
+       THEN
+          message_string = 'topography is still not allowed with ' // &
+                           'momentum_advec = "' // TRIM( momentum_advec ) //  &
+                           '"or scalar_advec = "' // TRIM( scalar_advec ) //'"'
+   ! message number still needs modification
+           CALL message( 'check_parameters', 'PA0341', 1, 2, 0, 6, 0 )
+       END IF
+          
 !
 !--    In case of non-flat topography, check whether the convention how to 
@@ -492,23 +566,31 @@
        CALL message( 'check_parameters', 'PA0021', 1, 2, 0, 6, 0 )
     ENDIF
-
+    
+    IF( momentum_advec == 'ws-scheme' .AND. & 
+        call_psolver_at_all_substeps == .FALSE. ) THEN
+        message_string = 'psolver must be called at each RK3 substep when "'//&
+                      TRIM(momentum_advec) // ' "is used for momentum_advec'
+        CALL message( 'check_parameters', 'PA0343', 1, 2, 0, 6, 0 )
+    END IF
 !
 !-- Advection schemes:
-    IF ( momentum_advec /= 'pw-scheme' .AND. momentum_advec /= 'ups-scheme' ) &
-    THEN
+    IF ( momentum_advec /= 'pw-scheme' .AND. momentum_advec /= 'ws-scheme' .AND. &
+         momentum_advec /= 'ups-scheme' ) THEN
        message_string = 'unknown advection scheme: momentum_advec = "' // &
                         TRIM( momentum_advec ) // '"'
        CALL message( 'check_parameters', 'PA0022', 1, 2, 0, 6, 0 )
     ENDIF
-    IF ( ( momentum_advec == 'ups-scheme'  .OR.  scalar_advec == 'ups-scheme' )&
-                                      .AND.  timestep_scheme /= 'euler' )  THEN
-       message_string = 'momentum_advec = "' // TRIM( momentum_advec ) // &
-                        '" is not allowed with timestep_scheme = "' //    &
-                        TRIM( timestep_scheme ) // '"'
+    IF ((( momentum_advec == 'ups-scheme'  .OR.  scalar_advec == 'ups-scheme' )&
+           .AND.  timestep_scheme /= 'euler' ) .OR. (( momentum_advec == 'ws-scheme'&
+           .OR.  scalar_advec == 'ws-scheme') .AND. (timestep_scheme == 'euler' .OR. &
+           timestep_scheme == 'leapfrog+euler' .OR. timestep_scheme == 'leapfrog'    &
+           .OR. timestep_scheme == 'runge-kutta-2'))) THEN
+       message_string = 'momentum_advec or scalar_advec = "' &
+         // TRIM( momentum_advec ) // '" is not allowed with timestep_scheme = "' // &
+         TRIM( timestep_scheme ) // '"'
        CALL message( 'check_parameters', 'PA0023', 1, 2, 0, 6, 0 )
     ENDIF
-
-    IF ( scalar_advec /= 'pw-scheme'  .AND.  scalar_advec /= 'bc-scheme'  .AND.&
-         scalar_advec /= 'ups-scheme' )  THEN
+    IF ( scalar_advec /= 'pw-scheme'  .AND.  scalar_advec /= 'ws-scheme' .AND. &
+        scalar_advec /= 'bc-scheme'  .AND.  scalar_advec /= 'ups-scheme' )  THEN
        message_string = 'unknown advection scheme: scalar_advec = "' // &
                         TRIM( scalar_advec ) // '"'
@@ -563,6 +645,6 @@
     ENDIF
 
-    IF ( momentum_advec /= 'pw-scheme' .AND. timestep_scheme(1:5) == 'runge' ) &
-    THEN
+    IF ( (momentum_advec /= 'pw-scheme' .AND. momentum_advec /= 'ws-scheme') &
+         .AND. timestep_scheme(1:5) == 'runge' ) THEN
        message_string = 'momentum advection scheme "' // &
                         TRIM( momentum_advec ) // '" & does not work with ' // &
@@ -712,5 +794,5 @@
           ug_vertical_gradient_level_ind(1) = nzt+1
           ug(nzt+1) = ug_surface
-          DO  k = nzt, 0, -1
+          DO  k = nzt, nzb, -1
              IF ( i < 11 ) THEN
                 IF ( ug_vertical_gradient_level(i) > zu(k)  .AND. &
@@ -778,5 +860,5 @@
           vg_vertical_gradient_level_ind(1) = nzt+1
           vg(nzt+1) = vg_surface
-          DO  k = nzt, 0, -1
+          DO  k = nzt, nzb, -1
              IF ( i < 11 ) THEN
                 IF ( vg_vertical_gradient_level(i) > zu(k)  .AND. &
@@ -1020,4 +1102,5 @@
  
              
+
 !
 !-- Compute Coriolis parameter
@@ -1159,6 +1242,6 @@
 !
 !-- Non-cyclic lateral boundaries require the multigrid method and Piascek-
-!-- Willimas advection scheme. Several schemes and tools do not work with
-!-- non-cyclic boundary conditions.
+!-- Willimas or Wicker - Skamarock advection scheme. Several schemes
+!-- and tools do not work with non-cyclic boundary conditions.
     IF ( bc_lr /= 'cyclic'  .OR.  bc_ns /= 'cyclic' )  THEN
        IF ( psolver /= 'multigrid' )  THEN
@@ -1167,14 +1250,24 @@
           CALL message( 'check_parameters', 'PA0051', 1, 2, 0, 6, 0 )
        ENDIF
-       IF ( momentum_advec /= 'pw-scheme' )  THEN
+       IF ( momentum_advec /= 'pw-scheme' .AND. &
+            momentum_advec /= 'ws-scheme')  THEN
           message_string = 'non-cyclic lateral boundaries do not allow ' // &
                            'momentum_advec = "' // TRIM( momentum_advec ) // '"'
           CALL message( 'check_parameters', 'PA0052', 1, 2, 0, 6, 0 )
        ENDIF
-       IF ( scalar_advec /= 'pw-scheme' )  THEN
+       IF ( scalar_advec /= 'pw-scheme' .AND. &
+            scalar_advec /= 'ws-scheme' )  THEN
           message_string = 'non-cyclic lateral boundaries do not allow ' // &
                            'scalar_advec = "' // TRIM( scalar_advec ) // '"'
           CALL message( 'check_parameters', 'PA0053', 1, 2, 0, 6, 0 )
        ENDIF
+       IF ( (scalar_advec == 'ws-scheme' .OR. momentum_advec == 'ws-scheme' ) &
+          .AND. loop_optimization == 'vector' ) THEN
+          message_string = 'non-cyclic lateral boundaries do not allow ' // &
+                           'loop_optimization = vector and ' //  &
+                           'scalar_advec = "' // TRIM( scalar_advec ) // '"' 
+  ! The error message number still needs modification. 
+          CALL message( 'check_parameters', 'PA0342', 1, 2, 0, 6, 0 )
+       END IF
        IF ( galilei_transformation )  THEN
           message_string = 'non-cyclic lateral boundaries do not allow ' // &
@@ -1407,4 +1500,10 @@
                         TRIM( bc_uv_b ) // '"'
        CALL message( 'check_parameters', 'PA0076', 1, 2, 0, 6, 0 )
+    ENDIF
+!
+!-- In case of coupled simulations u and v at the ground in atmosphere will be
+!-- assigned with the u and v values of the ocean surface
+    IF ( coupling_mode == 'atmosphere_to_ocean' )  THEN
+       ibc_uv_b = 2
     ENDIF
 
@@ -2109,4 +2208,5 @@
              hom(:,2,57,:) = SPREAD( zu, 2, statistic_regions+1 )
 
+
           CASE ( 'u"pt"' )
              dopr_index(i) = 58
@@ -2244,4 +2344,5 @@
 
        END SELECT
+
 !
 !--    Check to which of the predefined coordinate systems the profile belongs
@@ -2584,5 +2685,7 @@
 !-- Upper plot limit (grid point value) for 1D profiles
     IF ( z_max_do1d == -1.0 )  THEN
+
        nz_do1d = nzt+1
+
     ELSE
        DO  k = nzb+1, nzt+1
@@ -2737,4 +2840,5 @@
 
 !
+
 !-- Check netcdf precison
     ldum = .FALSE.
@@ -3070,9 +3174,7 @@
     IF ( conserve_volume_flow )  THEN
        IF ( TRIM( conserve_volume_flow_mode ) == 'default' )  THEN
-          IF ( bc_lr /= 'cyclic'  .OR.  bc_ns /= 'cyclic' )  THEN
-             conserve_volume_flow_mode = 'inflow_profile'
-          ELSE
-             conserve_volume_flow_mode = 'initial_profiles'
-          ENDIF
+
+          conserve_volume_flow_mode = 'initial_profiles'
+
        ELSEIF ( TRIM( conserve_volume_flow_mode ) /= 'initial_profiles' .AND.  &
             TRIM( conserve_volume_flow_mode ) /= 'inflow_profile' .AND.  &
@@ -3082,8 +3184,8 @@
           CALL message( 'check_parameters', 'PA0154', 1, 2, 0, 6, 0 )
        ENDIF
-       IF ( ( bc_lr /= 'cyclic'  .OR.  bc_ns /= 'cyclic' ) .AND. &
-            TRIM( conserve_volume_flow_mode ) /= 'inflow_profile' )  THEN
-          WRITE( message_string, * )  'noncyclic boundary conditions ', &
-               'require & conserve_volume_flow_mode = ''inflow_profile'''
+       IF ( (bc_lr /= 'cyclic'  .OR.  bc_ns /= 'cyclic')  .AND. &
+          TRIM( conserve_volume_flow_mode ) == 'bulk_velocity' )  THEN
+          WRITE( message_string, * )  'non-cyclic boundary conditions ', &
+               'require  conserve_volume_flow_mode = ''initial_profiles'''
           CALL message( 'check_parameters', 'PA0155', 1, 2, 0, 6, 0 )
        ENDIF
@@ -3091,5 +3193,5 @@
             TRIM( conserve_volume_flow_mode ) == 'inflow_profile' )  THEN
           WRITE( message_string, * )  'cyclic boundary conditions ', &
-               'require & conserve_volume_flow_mode = ''initial_profiles''', &
+               'require conserve_volume_flow_mode = ''initial_profiles''', &
                ' or ''bulk_velocity'''
           CALL message( 'check_parameters', 'PA0156', 1, 2, 0, 6, 0 )
@@ -3100,5 +3202,5 @@
          TRIM( conserve_volume_flow_mode ) /= 'bulk_velocity' ) )  THEN
        WRITE( message_string, * )  'nonzero bulk velocity requires ', &
-            'conserve_volume_flow = .T. and & ', &
+            'conserve_volume_flow = .T. and ', &
             'conserve_volume_flow_mode = ''bulk_velocity'''
        CALL message( 'check_parameters', 'PA0157', 1, 2, 0, 6, 0 )
@@ -3139,3 +3241,4 @@
 
 
+
  END SUBROUTINE check_parameters
